## net.sf.saxon.regex
Class SurrogateRegexTranslator.Complement

    java.lang.Object
      net.sf.saxon.regex.SurrogateRegexTranslator.CharClass
          net.sf.saxon.regex.SurrogateRegexTranslator.Complement

Enclosing class:
  SurrogateRegexTranslator

    public static class SurrogateRegexTranslator.Complement

extends SurrogateRegexTranslator.CharClass

Character class representing the complement of another character class, that is, all characters that the other class doesn't match.

Constructor Summary
`SurrogateRegexTranslator.Complement(SurrogateRegexTranslator.CharClass cc)` Create a character class representing the complement of another character class

Method Summary
`void` `addNonBmpRanges(java.util.List ranges)` Add to a supplied List, ranges of non-BMP characters that are matched by this character class.
`void` `outputBmp(FastStringBuffer buf)` Output a representation of the subset of this character class that's within the BMP, to a supplied buffer
`void` `outputComplementBmp(FastStringBuffer buf)` Output a representation of the complement of the subset of this character class that's within the BMP, to a supplied buffer

Methods inherited from class net.sf.saxon.regex.SurrogateRegexTranslator.CharClass
`getContainsBmp, getContainsNonBmp, getSingleChar, output`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SurrogateRegexTranslator.Complement

    public SurrogateRegexTranslator.Complement(SurrogateRegexTranslator.CharClass cc)

  Create a character class representing the complement of another character class

  Parameters:
    `cc` - the character class of which this is the complement

Method Detail

### outputBmp

    public void outputBmp(FastStringBuffer buf)

  Description copied from class: `SurrogateRegexTranslator.CharClass`
  Output a representation of the subset of this character class that's within the BMP, to a supplied buffer

  Specified by:
    `outputBmp` in class `SurrogateRegexTranslator.CharClass`
  Parameters:
    `buf` - the supplied buffer

### outputComplementBmp

    public void outputComplementBmp(FastStringBuffer buf)

  Description copied from class: `SurrogateRegexTranslator.CharClass`
  Output a representation of the complement of the subset of this character class that's within the BMP, to a supplied buffer

  Specified by:
    `outputComplementBmp` in class `SurrogateRegexTranslator.CharClass`
  Parameters:
    `buf` - the supplied buffer

### addNonBmpRanges

    public void addNonBmpRanges(java.util.List ranges)

  Description copied from class: `SurrogateRegexTranslator.CharClass`
  Add to a supplied List, ranges of non-BMP characters that are matched by this character class. Default implementation does nothing.

  Overrides:
    `addNonBmpRanges` in class `SurrogateRegexTranslator.CharClass`
  Parameters:
    `ranges` - a List to which this method will add zero or more Range objects denoting ranges of non-BMP characters

Copyright (c) Saxonica Limited. All rights reserved.